

<!DOCTYPE html>
<!--[if IE 8]><html class="no-js lt-ie9" lang="en" > <![endif]-->
<!--[if gt IE 8]><!--> <html class="no-js" lang="en" > <!--<![endif]-->
<head>
  <meta charset="utf-8">
  
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  
  <title>Lisp Implementation Documentation &mdash; libstephen 0.1 documentation</title>
  

  
  

  

  
  
    

  

  
  
    <link rel="stylesheet" href="../_static/css/theme.css" type="text/css" />
  

  

  
        <link rel="index" title="Index"
              href="../genindex.html"/>
        <link rel="search" title="Search" href="../search.html"/>
    <link rel="top" title="libstephen 0.1 documentation" href="../index.html"/>
        <link rel="next" title="Embedding the Interpreter" href="embedding.html"/>
        <link rel="prev" title="String Functions" href="../api/str.html"/> 

  
  <script src="../_static/js/modernizr.min.js"></script>

</head>

<body class="wy-body-for-nav" role="document">

  <div class="wy-grid-for-nav">

    
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search">
          

          
            <a href="../index.html" class="icon icon-home"> libstephen
          

          
          </a>

          
            
            
              <div class="version">
                0.1
              </div>
            
          

          
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="../search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>

          
        </div>

        <div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="main navigation">
          
            
            
                <ul class="current">
<li class="toctree-l1"><a class="reference internal" href="../tutorial/index.html">Libstephen Tutorial</a></li>
<li class="toctree-l1"><a class="reference internal" href="../api/index.html">Libstephen API Documentation</a></li>
<li class="toctree-l1 current"><a class="current reference internal" href="#">Lisp Implementation Documentation</a><ul>
<li class="toctree-l2"><a class="reference internal" href="embedding.html">Embedding the Interpreter</a></li>
<li class="toctree-l2"><a class="reference internal" href="types.html">Type System</a></li>
</ul>
</li>
</ul>

            
          
        </div>
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap">

      
      <nav class="wy-nav-top" role="navigation" aria-label="top navigation">
        <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
        <a href="../index.html">libstephen</a>
      </nav>


      
      <div class="wy-nav-content">
        <div class="rst-content">
          

 



<div role="navigation" aria-label="breadcrumbs navigation">
  <ul class="wy-breadcrumbs">
    <li><a href="../index.html">Docs</a> &raquo;</li>
      
    <li>Lisp Implementation Documentation</li>
      <li class="wy-breadcrumbs-aside">
        
          
            <a href="../_sources/lisp/index.rst.txt" rel="nofollow"> View page source</a>
          
        
      </li>
  </ul>
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
            
  <div class="section" id="lisp-implementation-documentation">
<h1>Lisp Implementation Documentation<a class="headerlink" href="#lisp-implementation-documentation" title="Permalink to this headline">¶</a></h1>
<p>Included in libstephen (for some reason) is a somewhat functional lisp
implementation. This feature is intended to provide some lightweight scripting
capabilities for applications using the library, without having to link to a
more complex tool like Python or Lua.</p>
<p>For instance it may be possible for an application to write all its routines in
a way that they are callable from libstephen&#8217;s lisp interpreter, and then to run
the main program as a small lisp script. Or an application could use the lisp
implementation as a powerful and easy to use configuration language for startup.
A final possibility might be enabling extensions and plugins for an application.</p>
<p>This section is organized so that the documentation required for a library user
to embed the interpreter is presented first. More advanced information about the
inner workings of the interpreter is presented later.</p>
<p>Contents:</p>
<div class="toctree-wrapper compound">
<ul>
<li class="toctree-l1"><a class="reference internal" href="embedding.html">Embedding the Interpreter</a><ul>
<li class="toctree-l2"><a class="reference internal" href="embedding.html#basic-components">Basic Components</a></li>
<li class="toctree-l2"><a class="reference internal" href="embedding.html#the-repl">The REPL</a></li>
<li class="toctree-l2"><a class="reference internal" href="embedding.html#writing-builtins">Writing Builtins</a></li>
<li class="toctree-l2"><a class="reference internal" href="embedding.html#basics-of-lisp-types">Basics of Lisp Types</a></li>
<li class="toctree-l2"><a class="reference internal" href="embedding.html#adding-builtins-to-the-scope">Adding Builtins to the Scope</a></li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="types.html">Type System</a></li>
</ul>
</div>
</div>


           </div>
          </div>
          <footer>
  
    <div class="rst-footer-buttons" role="navigation" aria-label="footer navigation">
      
        <a href="embedding.html" class="btn btn-neutral float-right" title="Embedding the Interpreter" accesskey="n">Next <span class="fa fa-arrow-circle-right"></span></a>
      
      
        <a href="../api/str.html" class="btn btn-neutral" title="String Functions" accesskey="p"><span class="fa fa-arrow-circle-left"></span> Previous</a>
      
    </div>
  

  <hr/>

  <div role="contentinfo">
    <p>
        &copy; Copyright 2013-2016, Stephen Brennan.

    </p>
  </div>
  Built with <a href="http://sphinx-doc.org/">Sphinx</a> using a <a href="https://github.com/snide/sphinx_rtd_theme">theme</a> provided by <a href="https://readthedocs.org">Read the Docs</a>. 

</footer>

        </div>
      </div>

    </section>

  </div>
  


  

    <script type="text/javascript">
        var DOCUMENTATION_OPTIONS = {
            URL_ROOT:'../',
            VERSION:'0.1',
            COLLAPSE_INDEX:false,
            FILE_SUFFIX:'.html',
            HAS_SOURCE:  true
        };
    </script>
      <script type="text/javascript" src="../_static/jquery.js"></script>
      <script type="text/javascript" src="../_static/underscore.js"></script>
      <script type="text/javascript" src="../_static/doctools.js"></script>

  

  
  
    <script type="text/javascript" src="../_static/js/theme.js"></script>
  

  
  
  <script type="text/javascript">
      jQuery(function () {
          SphinxRtdTheme.StickyNav.enable();
      });
  </script>
   

</body>
</html>